import { DateTime } from 'luxon'
import { pki } from 'node-forge'

export class CertificateBuilder {
  /**
   * Generates a self-signed certificate.
   * <p>
   *   The input argument can be generated by {@link KeyBuilder}.
   *
   *   ```js
   *   const keyPair = KeyBuilder.buildKeyPair();
   *   const certificate = CertificateBuilder.createCertificate(keyPair);
   *   ```
   * </p>
   * <p>
   *   The certificate can be converted to the PEM format too.
   *
   *   ```js
   *   const pem = pki.certificateToPem(cert);
   *   ```
   * </p>
   * <p>
   *   Please see <a href="https://github.com/digitalbazaar/forge">node-forge</a>'s documentation for more possibilities.
   * </p>
   */
  static createCertificate(
    keyPair: pki.KeyPair,
    notBefore: DateTime = DateTime.now(),
    notAfter: DateTime = DateTime.now().plus({ year: 1 })
  ): pki.Certificate {
    const cert = pki.createCertificate()

    cert.publicKey = keyPair.publicKey
    cert.serialNumber = '01'
    cert.validity.notBefore = notBefore.toJSDate()
    cert.validity.notAfter = notAfter.toJSDate()

    const attrs: pki.CertificateField[] = [
      {
        name: 'commonName',
        value: 'dev.gaia-x.eu'
      },
      {
        name: 'countryName',
        value: 'FR'
      },
      {
        shortName: 'ST',
        value: 'Nouvelle-Aquitaine'
      },
      {
        name: 'localityName',
        value: 'Bordeaux'
      },
      {
        name: 'organizationName',
        value: 'Gaia-X Dev'
      },
      {
        shortName: 'OU',
        value: 'CTO Team'
      }
    ]
    cert.setSubject(attrs)
    cert.setIssuer(attrs)

    cert.setExtensions([
      {
        name: 'basicConstraints',
        cA: true
      },
      {
        name: 'keyUsage',
        keyCertSign: true,
        digitalSignature: true,
        nonRepudiation: true,
        keyEncipherment: true,
        dataEncipherment: true
      },
      {
        name: 'extKeyUsage',
        serverAuth: true,
        clientAuth: true,
        codeSigning: true,
        emailProtection: true,
        timeStamping: true
      },
      {
        name: 'nsCertType',
        client: true,
        server: true,
        email: true,
        objsign: true,
        sslCA: true,
        emailCA: true,
        objCA: true
      },
      {
        name: 'subjectAltName',
        altNames: [
          {
            type: 2, // DNS
            value: 'localhost'
          },
          {
            type: 7, // IP
            ip: '127.0.0.1'
          }
        ]
      },
      {
        name: 'subjectKeyIdentifier'
      }
    ])

    cert.sign(keyPair.privateKey)

    return cert
  }
}
